/* mnet.c - mesh networking utils
 * marius aamodt eriksen (marius@umich.edu)
 * $Id: mnet.c,v 1.8 2002/01/14 05:11:45 beriksen Exp $ */


#include "nylon.h"

#if defined(SENDN) || defined(RECVN)
ssize_t
#if defined(RECVN)
recvn
#elif defined(SENDN)
sendn
#endif
(int s, void *buf, size_t len, int flags)
{
	unsigned bytes = 0, bytes_left = len;
	
	while (bytes_left > 0) {
		if ( (bytes =
#if defined(RECVN)
			  recv
#elif defined(SENDN)
			  send
#endif
			  (s, buf+(len-bytes_left), bytes_left, flags)) >= 0 )
			bytes_left -= bytes;
		else
#if defined(RECVN)
			if (bytes == EINTR)
				continue;
			else
#endif /* RECVN */
				return bytes;
	}
	return len;
}
#endif /* defined(SENDN) || defined(RECVN) */

#if !defined(RECVN) && !defined(SENDN)
/* void */
#endif

/* copyright (c) 2001  
 * marius aamodt eriksen
 * all rights reserved
 * 
 * permission is granted to use, copy, create derivative works and
 * redistribute this software and such derivative works for any purpose,
 * so long as the name of the author is not used in any advertising or 
 * publicity pertaining to the use or distribution of this software 
 * without specific, written prior authorization.  if the above copyright 
 * notice or any other identification of the author is included in any 
 * copy of any portion of this software, then the disclaimer below must 
 * also be included.
 * 
 * this software is provided as is, without representation from the
 * the author as to its fitness for any purpose, and without warranty by 
 * the author of any kind, either express or implied, including without 
 * limitation the implied warranties of merchantability and fitness for 
 * a particular purpose.  the author shall not be liable for any damages,
 * including special, indirect, incidental, or consequential damages,
 * with respect to any claim arising out or in connection with the use
 * of the software, even if it has been or is hereafter advised of the
 * possibility of such damages. */
